<template>
  <single-pane :capt="dictionaryRu.title">
    <div
      :class="{'hidden': pending}"
      class="resource-types-table-wrapper"
    >
      <ob-functional-panel
        :columns="columns"
        :show-refresh="true"
        @onRefresh="onRefresh"
        @search="onSearch"
      />

      <div
        v-for="(type, index) in getItems()"
        :key="index"
        class="ob-accordion__item"
      >
        <div
          class="ob-accordion__title"
          @click="openAccordion(type)"
        >
          <i
            v-if="type._isOpen"
            class="icon chevron-up"
          />
          <i
            v-if="!type._isOpen"
            class="icon chevron-down"
          />
          <div class="ob-accordion__title-text">{{ type.title }}</div>
        </div>

        <div
          v-if="type._isOpen"
          class="ob-accordion__content"
        >
          <ob-table
            :columns="columns"
            :items="getItems(type.uuid)"
            :footerDisabled="true"
            :pageLimit="1000"
            @select="onSelectionItem"
          />
        </div>
      </div>
      <div class="table-footer">
        <ObPagination
            :page="pagination.pageNum"
            :count="pagination.totalElements"
            :page-limit="pagination.pageSize"
            @on-change="clickPage"
        />
      </div>
    </div>

    <div
      :class="{'hidden': !pending}"
      class="spinner"
    />

    <ob-modal
      ref="viewItem"
      :title="dictionaryRu.modal.title"
      :data-grid="$refs.dataGrid"
      custom-class="modal-medium"
    >
      <resource-type
        v-if="selectedData.uuid"
        :data-source="selectedData"
        :disabled-form="!newStatus"
        :masks="masks"
        @save="onSave"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import api from '@/api';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ResourceType from './modal/ResourceType';
import ObModal from 'common-components/src/obComponents/obModal';
import ObTable from 'common-components/src/obComponents/obTable/index';
import ObFunctionalPanel from 'common-components/src/obComponents/obFuncPanel';
import ResourceTypeStream from './resourceTypeStream';
import ObPagination from 'common-components/src/obComponents/obPagination'
import { dictionaryDefault } from '@/translations/ru/default';
import { dictionary } from '@/translations/ru/dictionaries__resources__resource_types';

String.prototype.replaceAll = function(search, replace) {
  let index = this.search(search);
  let str = this.replace(new RegExp(search, 'gm'), '');
  return str.slice(0, index) + replace + str.slice(index);
};

export default {
  name: 'ResourceTypes',
  components: { ObTable, ObModal, ResourceType, SinglePane, ObFunctionalPanel, ObPagination },
  computed: {
    columns() {
      return [
        {
          title: this.dictionaryRu.columns.resource_pattern,
          key: 'title',
          html: data => {
            if (!data.isMask) {
              return `<span>${data.title}</span> <span class="resource-type__link">${this.dictionaryRu.assign_title}</span>`;
            } else {
              return data.maskTitle;
            }
          },
          action: data => {
            this.onClickTypeResource(data, event);
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          key: 'deleted_at',
          html: data =>
            data.no_use
              ? ''
              : data.deleted_at
              ? this.dictionaryRu.status.inactive
              : this.dictionaryRu.status.active
        }
      ];
    }
  },
  data() {
    return {
      pagination: {
        pageNum: 0,
        totalElements: 0,
        totalPages: 0,
        pageSize: 50,
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault),
      pending: true,
      resourceTypes: [],
      groups: [],
      selectedData: {},
      newData: {
        resource_species_uuid: '',
        resourceSubTypeUuid: '',
        resourcePatternUuids: [],
        resourceSubTypeDTO: { name: '' },
        resource_species: { name: '' },
        mask: ''
      },
      api: {
        source: 'resources',
        method: 'getResourceTypes',
        viewItem: 'getResourceType',
        createItem: 'createForwardingUnit',
        editItem: 'editForwardingUnit'
      },
      masks: [],
      types: [],
      subTypes: {},
      patterns: [],
      dataSource: [],
      count: 0,
      query: ''
    };
  },
  mounted() {
    this.getDataSource();
  },

  methods: {
    clickPage(page) {
      this.pagination.pageNum = page;
      this.getDataSource();
    },
    getItems(uuid) {
      if (this.query) {
        return this.dataSource.filter(i =>
          uuid
            ? i.parent === uuid &&
              i.maskTitle.toLowerCase().includes(this.query.toLowerCase())
            : i.parent === uuid &&
              this.dataSource.find(
                si =>
                  si.parent === i.uuid &&
                  si.maskTitle.toLowerCase().includes(this.query.toLowerCase())
              )
        );
      }
      else {
        return this.dataSource.filter(i => i.parent === uuid);
      }
    },
    onRefresh() {
      this.getDataSource();
    },
    openAccordion(type) {
      type._isOpen = !type._isOpen;
    },
    async getDataSource() {
      this.pending = true;
      let resourceTypeStream = new ResourceTypeStream();
      await resourceTypeStream
        .loadData(this.pagination.pageNum, this.pagination.pageSize)
        .then(res => {
          this.dataSource = res;
          this.masks = resourceTypeStream.getMasks();
          this.pagination = resourceTypeStream.getPagination()
        })
        .catch(e => {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки типов ресурсов: ' + e
          });
        });
      this.pending = false;
    },
    onClickTypeResource(data, ev) {
      if (ev.target.className == 'resource-type__link') {
        this.newMasks(data);
      } else {
        this.onSelectionItem(data);
      }
    },
    newMasks(data) {
      this.preparedSelectedData(data, [], true);
    },
    async onSelectionItem(data) {
      try {
        let _data = data;
        let res = {};
        if (data.typeUuid) {
          res = await api.resources.getFilteredPatterns(data.typeUuid);
        } else {
          this.newMasks(data);
          return;
        }
        this.preparedSelectedData(
          { ..._data, ...{ maskUuid: res.data.maskUuid } },
          res.data.currentPatterns,
          false
        );
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    async preparedSelectedData(data, patterns, status) {
      let parent = this.dataSource.find(i => i.uuid === data.parent);
      this.newStatus = status;
      this.selectedData = data;
      await this.$set(
        this.selectedData,
        'resourcePatternUuids',
        status
          ? []
          : patterns.map(pattern => {
              return pattern.uuid;
            })
      );
      await this.$set(this.selectedData, 'uuid', parent.uuid);
      await this.$set(this.selectedData, 'name', parent.title);
      await this.$set(this.selectedData, 'title', data.title);
      await this.$set(
        this.selectedData,
        'resource_mask_uuid',
        status ? '' : data.maskUuid
      );
      await this.$set(this.selectedData, 'resource_species_uuid', data.uuid);
      await this.$set(
        this.selectedData,
        'resourceSubTypeUuid',
        data.resourceSubTypeUuid
      );
      await this.$set(this.selectedData, 'status', status);
      this.$refs.viewItem.open();
    },
    onSave() {
      this.getDataSource();
      this.$refs.viewItem.close();
    },
    onSearch(query) {
      this.query = query;
    }
  }
};
</script>

<style lang="scss">
.custom-template {
  width: 100%;
  img {
    display: inline-block;
  }
  .custom-input {
    display: inline-block;
    width: calc(100% - 21px);
  }
}
.resource-type {
  &__link {
    margin-left: 7px;
    font-size: 14px;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: $color-blue-navy-blue;
    cursor: pointer;
  }
}
.resource-types-table-wrapper {
  transition: opacity 0.3s ease;
  will-change: opacity;
  &.hidden {
    opacity: 0;
    pointer-events: none;
    height: 0;
  }
}

.ob-accordion {
  display: flex;
  background: $background-white;
  flex-direction: column;
  width: 100%;

  &__header {
    display: flex;
    width: 100%;
    height: 40px;
    padding-left: 44px;
    border-bottom: 1px solid $lavender;

    &-item {
      display: flex;
      flex-direction: column;
      justify-content: center;
      color: $shale-gray;
      font-size: 11px;
      line-height: 12px;
      font-variant: small-caps;
      text-transform: uppercase;
      flex-basis: 20%;

      &:nth-child(3) {
        flex-basis: 10%;
      }
      &:nth-child(4) {
        flex-basis: 50%;
      }
    }
  }
  &__item {
    display: flex;
    flex-direction: column;
    border-left: none;
    border-right: none;
  }
  &__title {
    padding: 10px 15px 10px 15px;
    color: $color-blue-navy-blue;
    display: flex;
    cursor: pointer;
    font-size: 14px;
    border-bottom: 1px solid $lavender;

    &-text {
      margin-left: 15px;
    }
  }

  &__content {
    &-table {
      width: 100%;
      &-row {
        display: flex;
        border-bottom: 1px solid $lavender;
        padding: 8px 0;
        padding-left: 44px;
        min-height: 40px;
      }
      &-cell {
        display: flex;
        flex-direction: column;
        justify-content: center;
        font-size: 14px;
        line-height: 20px;
        flex-basis: 20%;
        color: $color-text-base;
        &:nth-child(3) {
          flex-basis: 10%;
          align-items: center;
        }
        &:nth-child(4) {
          flex-basis: 50%;
          i {
            margin-left: 6px;
          }
        }
      }
    }
  }
}
</style>
